/*****************************************************************************/
/* N.A.D.A.R. - A network tank battle game.                                  */
/*                                                                           */
/* N.A.D.A.R. Copyright (c) 2000-2001 Sakai Hiroaki.                         */
/* All Rights Reserved.                                                      */
/*                                                                           */
/* N.A.D.A.R. is a network tank battle game. You get into a tank,            */
/* operate it, and destroy other tanks to survive!                           */
/*****************************************************************************/

/*****************************************************************************/
/* Enemy 饹(ŨΥ饹)Υ饤֥                                */
/*****************************************************************************/

/*****************************************************************************/
/*                                                                   */
/*****************************************************************************/

#include "EnemyP.h"

/*****************************************************************************/
/* ؿ                                                                */
/*****************************************************************************/

/*===========================================================================*/
/* ѿμ                                                    */
/*===========================================================================*/

int EnemyGetType(Enemy e)           { return (e->type       ); }
int EnemySetType(Enemy e, int type) { return (e->type = type); }

/*===========================================================================*/
/* Ũΰư                                                                  */
/*===========================================================================*/

#if 0
static int EscapeCanon(Enemy enemy, Map map,
		       ObjList canon_list, ObjList missile_list)
{
  Tank tank;
  Canon canon;
  Missile missile;
  ObjListData current;
  double x, y, vx, vy, tx, ty, dx, dy, d, size;
  int i;

  tank = PlayerGetTank((Player)enemy);
  tx = TankGetX(tank);
  ty = TankGetY(tank);

  size = (double)EXPLOSION_SIZE / CHARACTER_SIZE * 0.5 * 1.2 * 2.0;

  for (current = ObjList_GetStart(canon_list);
       !ObjList_IsEndEdge(canon_list, current);
       current = ObjListData_GetNext(current)) {
    canon = (Canon)ObjListData_GetObj(current);

    if (CanonGetState(canon) == CANON_DESTROY) continue;
    if (CanonGetTank(canon) == tank) continue;

    vx = CanonGetVX(canon);
    vy = CanonGetVY(canon);
    x  = CanonGetX( canon);
    y  = CanonGetY( canon);

    for (i = 0; i < 20; i++) {
      x += vx;
      y += vy;

      if (MapGetState(map,
		      ConvertXFromPositionToMap(x),
		      ConvertYFromPositionToMap(y)) != 0)
	break;

      dx = x - tx;
      dy = y - ty;
      d = dx * dx + dy * dy;
      if (d < size * size) {
	if (enemy->state != ENEMY_STATE_ESCAPE) {
	  enemy->state = ENEMY_STATE_ESCAPE;

	  if (GetRandomValue(2))
	    enemy->action |= TANK_GO_FORWARD;
	  else
	    enemy->action |= TANK_GO_BACKWARD;

	  switch (GetRandomValue(4)) {
	    case 0: enemy->action |= TANK_TURN_LEFT;  break;
	    case 1: enemy->action |= TANK_TURN_RIGHT; break;
	  }
	}
	return (1);
      }
    }
  }

  size = (double)EXPLOSION_SIZE / CHARACTER_SIZE * 0.5 * 1.2 * 20.0;

  for (current = ObjList_GetStart(missile_list);
       !ObjList_IsEndEdge(missile_list, current);
       current = ObjListData_GetNext(current)) {
    missile = (Missile)ObjListData_GetObj(current);

    if (MissileGetTarget(missile) != tank) continue;

    dx = MissileGetX(missile) - tx;
    dy = MissileGetY(missile) - ty;
    d = dx * dx + dy * dy;
    if (d > size * size) continue;
    if ((enemy->state != ENEMY_STATE_ESCAPE) || (GetRandomValue(5) == 0)) {
      enemy->action &= ~(TANK_GO_FORWARD | TANK_GO_BACKWARD);
      enemy->action &= ~(TANK_TURN_LEFT | TANK_TURN_RIGHT);
      if (GetRandomValue(2))
	enemy->action |= TANK_GO_FORWARD;
      else
	enemy->action |= TANK_GO_BACKWARD;
      switch (GetRandomValue(4)) {
      case 0: enemy->action |= TANK_TURN_LEFT;  break;
      case 1: enemy->action |= TANK_TURN_RIGHT; break;
      }
    }
    enemy->state = ENEMY_STATE_ESCAPE;
    return (1);
  }

  enemy->state = ENEMY_STATE_NONE;
  return (0);
}
#endif

#if 0
static int ShotCanon(Enemy enemy, Map map, ObjList tank_list)
{
  Tank tank, other_tank;
  double x, y, vx, vy;
  double tx, ty, dx, dy, d;
  int i;
  ObjListData current;
  double size;

  tank = PlayerGetTank((Player)enemy);
  x = TankGetX(tank); vx = TankGetVX(tank);
  y = TankGetY(tank); vy = TankGetVY(tank);

  size = (double)EXPLOSION_SIZE / CHARACTER_SIZE * 0.5 * 1.2 * 0.5;

  for (i = 0; i < 30; i++) {
    x += vx;
    y += vy;
    size += (double)EXPLOSION_SIZE / CHARACTER_SIZE * 0.02;
    if (MapGetState(map,
		    ConvertXFromPositionToMap(x),
		    ConvertYFromPositionToMap(y)) != 0)
      break;
    for (current = ObjList_GetStart(tank_list);
         !ObjList_IsEndEdge(tank_list, current);
         current = ObjListData_GetNext(current)) {
      other_tank = (Tank)ObjListData_GetObj(current);
      if (tank == other_tank) continue;
      if (TankGetState(other_tank) != TANK_ACTIVE) continue;
      tx = TankGetX(other_tank);
      ty = TankGetY(other_tank);
      dx = x - tx;
      dy = y - ty;
      d = dx * dx + dy * dy;
      if (d < size * size) {
	if (GetRandomValue(10))
	  enemy->action |= TANK_FIRE_CANON;
	else
	  enemy->action |= TANK_FIRE_MISSILE;
	return (0);
      }
    }
  }
  enemy->action &= ~(TANK_FIRE_CANON | TANK_FIRE_MISSILE);
  return (0);
}
#endif

static int calc_range(double x0, double y0, double x1, double y1, double r)
{
  double dx, dy;
  if (!r) return (1);
  dx = x0 - x1;
  dy = y0 - y1;
  if (dx * dx + dy * dy <= r * r) return (1);
  return (0);
}

#define ESCAPE_FLAG (1 << 0)
#define SHOT_FLAG (1 << 1)

static int ShotOrEscape(unsigned long int flags,
			Enemy enemy, Map map,
			ObjList tank_list_orig, ObjList canon_list_orig,
			ObjList missile_list_orig, ObjList explosion_list_orig,
			int range, int depth, int * moved, double * d)
{
  ObjList tank_list;
  ObjList canon_list;
  ObjList missile_list;
  ObjList explosion_list;
  ObjListData current, current2;
  Tank tank_orig, tank;
  Canon canon_orig, canon;
  Missile missile_orig, missile;
  Explosion explosion_orig, explosion;
  Tank enemy_tank, target_tank;
  int i;
  int ret_value = -1;
  unsigned long int current_action;
  double dx, dy;

  MapUndo(map);

  tank_list = ObjList_Create();
  canon_list = ObjList_Create();
  missile_list = ObjList_Create();
  explosion_list = ObjList_Create();

  enemy_tank = PlayerGetTank((Player)enemy);
  target_tank = enemy->target;
  if (moved) *moved = 0;
  if (d) *d = 0.0;

  if (canon_list_orig) {
    for (current = ObjList_GetStart(canon_list_orig);
	 !ObjList_IsEndEdge(canon_list_orig, current);
	 current = ObjListData_GetNext(current)) {
      canon_orig = (Canon)ObjListData_GetObj(current);
      if (CanonGetState(canon_orig) != CANON_ACTIVE) continue;
      if (!calc_range(TankGetX(enemy_tank), TankGetY(enemy_tank),
		      CanonGetX(canon_orig), CanonGetY(canon_orig), range))
	continue;
      canon = CanonCreateFromCanon(canon_orig);
      ObjList_InsertObjToEnd(canon_list, canon,
			     (ObjDestructor)CanonDestroy);
    }
  }

  if (missile_list_orig) {
    for (current = ObjList_GetStart(missile_list_orig);
	 !ObjList_IsEndEdge(missile_list_orig, current);
	 current = ObjListData_GetNext(current)) {
      missile_orig = (Missile)ObjListData_GetObj(current);
      if (MissileGetState(missile_orig) != MISSILE_ACTIVE) continue;
      if (!calc_range(TankGetX(enemy_tank), TankGetY(enemy_tank),
		      MissileGetX(missile_orig), MissileGetY(missile_orig),
		      range))
	continue;
      missile = MissileCreateFromMissile(missile_orig);
      ObjList_InsertObjToEnd(missile_list, missile,
			     (ObjDestructor)MissileDestroy);
    }
  }

  if (explosion_list_orig) {
    for (current = ObjList_GetStart(explosion_list_orig);
	 !ObjList_IsEndEdge(explosion_list_orig, current);
	 current = ObjListData_GetNext(current)) {
      explosion_orig = (Explosion)ObjListData_GetObj(current);
      if (ExplosionGetState(explosion_orig) != EXPLOSION_ACTIVE) continue;
      if (!calc_range(TankGetX(enemy_tank), TankGetY(enemy_tank),
		      ExplosionGetX(explosion_orig),
		      ExplosionGetY(explosion_orig),
		      range))
	continue;
      explosion = ExplosionCreateFromExplosion(explosion_orig);
      ObjList_InsertObjToEnd(explosion_list, explosion,
			     (ObjDestructor)ExplosionDestroy);
    }
  }

  if (!tank_list_orig) {
    /*
     * ֤¾Υ֥Ȥ黲ȤƤΤǡNULL ϤǤʤ
     * ɬԡʤФʤʤ
     */
    ErrorExit("Tank list is NULL.");
  }

  for (current = ObjList_GetStart(tank_list_orig);
       !ObjList_IsEndEdge(tank_list_orig, current);
       current = ObjListData_GetNext(current)) {
    tank_orig = (Tank)ObjListData_GetObj(current);
    /*
     * ֤äˤƤȤޤĤäƤ꥿åȤˤʤäƤ뤫
     * ʤΤǡACTIVE ǤʤƤ⥹åפǤʤ
     */
    /* if (TankGetState(tank_orig) != TANK_ACTIVE) continue; */
    tank = TankCreateFromTank(tank_orig);
    ObjList_InsertObjToEnd(tank_list, tank,
			   (ObjDestructor)TankDestroy);

    /*
     * ץ쥤䡼ξ󤬸äƽ񤭴뤳ȤΤʤ褦
     * NULL ꤷƤ
     */
    TankSetPlayer(tank, NULL);

    if (enemy_tank == tank_orig) {
      enemy_tank = tank;
    }
    if (target_tank == tank_orig) {
      target_tank = tank;
    }

    for (current2 = ObjList_GetStart(canon_list);
	 !ObjList_IsEndEdge(canon_list, current2);
	 current2 = ObjListData_GetNext(current2)) {
      canon = (Canon)ObjListData_GetObj(current2);

      if (CanonGetTank(canon) == tank_orig) {
	/* ˤƤοƤѹ */
	CanonSetTank(canon, tank);
      }
    }

    for (current2 = ObjList_GetStart(missile_list);
	 !ObjList_IsEndEdge(missile_list, current2);
	 current2 = ObjListData_GetNext(current2)) {
      missile = (Missile)ObjListData_GetObj(current2);

      if (MissileGetTank(missile) == tank_orig) {
	/* ߥοƤѹ */
	MissileSetTank(missile, tank);
      }
      if (MissileGetTarget(missile) == tank_orig) {
	/* ߥΥåȤѹ */
	MissileSetTarget(missile, tank);
      }
    }

    for (current2 = ObjList_GetStart(explosion_list);
	 !ObjList_IsEndEdge(explosion_list, current2);
	 current2 = ObjListData_GetNext(current2)) {
      explosion = (Explosion)ObjListData_GetObj(current2);

      if (ExplosionGetTank(explosion) == tank_orig) {
	/* ȯοƤѹ */
	ExplosionSetTank(explosion, tank);
      }
    }
  }

  current_action = enemy->current_action;

  for (i = 0; i < depth; i++) {

    if (enemy->actions_num > current_action) {
      TankSetAction(enemy_tank, enemy->actions[current_action]);
      current_action++;
    } else {
      TankSetAction(enemy_tank, TANK_NO_ACTION);
    }

    /* ֤ν */
    StageProcTank(map, tank_list, canon_list, missile_list, explosion_list);
    if (moved)
      *moved += TankGetMoved(enemy_tank);

    /* ȯν */
    StageProcExplosion(map, explosion_list);

    /* ˤƤν */
    StageProcCanon(map, tank_list, canon_list, explosion_list);

    /* ߥν */
    StageProcMissile(map, tank_list, missile_list, explosion_list);

    if (flags & ESCAPE_FLAG) {
      if (TankGetState(enemy_tank) != TANK_ACTIVE) {
	ret_value = i;
	goto ret;
      }
    }

    if (flags & SHOT_FLAG) {
      for (current = ObjList_GetStart(tank_list);
	   !ObjList_IsEndEdge(tank_list, current);
	   current = ObjListData_GetNext(current)) {
	tank = (Tank)ObjListData_GetObj(current);
	if (tank == enemy_tank) continue;
	if (TankGetState(tank) != TANK_ACTIVE) {
	  if (TankGetDestroyed(tank) == enemy_tank) {
	    ret_value = i;
	    goto ret;
	  }
	}
      }
    }
  }

ret:

  if (d) {
    dx = TankGetX(enemy_tank) - TankGetX(target_tank);
    dy = TankGetY(enemy_tank) - TankGetY(target_tank);
    *d = dx * dx + dy * dy;
  }

  ObjList_Destroy(canon_list);
  ObjList_Destroy(missile_list);
  ObjList_Destroy(explosion_list);

  /* ֤¾Υ֥ȤοƤˤʤΤǡǸ˾õ */
  ObjList_Destroy(tank_list);

  return (ret_value);
}

static unsigned long int EnemyTurnToTarget(Enemy enemy)
{
  Tank tank;
  int degree, angle;
  unsigned long int action = TANK_NO_ACTION;

  if (enemy->target == NULL) return (TANK_NO_ACTION);

  tank = PlayerGetTank((Player)enemy);

  degree = easy_atan(TankGetX(enemy->target) - TankGetX(tank),
		     TankGetY(enemy->target) - TankGetY(tank));
  angle = (degree * TANK_ANGLE_NUMBER / 360) - TankGetAngle(tank);
  angle = (angle + TANK_ANGLE_NUMBER) % TANK_ANGLE_NUMBER;

  action = (angle > TANK_ANGLE_NUMBER / 2) ? TANK_TURN_LEFT : TANK_TURN_RIGHT;

  return (action);
}

#define RANDOM_ACTION_NO_FLAG              0
#define RANDOM_ACTION_FORWARD_ONLY        (1 << 0)
#define RANDOM_ACTION_FORWARD_OR_BACKWARD (1 << 1)
#define RANDOM_ACTION_TURN_TO_TARGET      (1 << 2)

static void SetRandomAction(Enemy enemy, int depth, int count,
			    unsigned long int flags)
{
  int i, j;
  unsigned long int actions[2][3] = {
    {
      TANK_GO_FORWARD,
      TANK_GO_FORWARD | TANK_TURN_LEFT,
      TANK_GO_FORWARD | TANK_TURN_RIGHT
    }, {
      TANK_GO_BACKWARD,
      TANK_GO_BACKWARD | TANK_TURN_LEFT,
      TANK_GO_BACKWARD | TANK_TURN_RIGHT
    }
  };
  unsigned long int action;
  int go_or_back = 0;

  if (flags & RANDOM_ACTION_FORWARD_ONLY)
    go_or_back = 0;
  else if (flags & RANDOM_ACTION_FORWARD_OR_BACKWARD)
    go_or_back = GetRandomValue(2);

  enemy->actions_num = 0;
  enemy->current_action = 0;
  for (i = 0; i < count; i++) {
    if (!(flags & (RANDOM_ACTION_FORWARD_ONLY |
		   RANDOM_ACTION_FORWARD_OR_BACKWARD)))
      go_or_back = GetRandomValue(2);
    action = actions[go_or_back][GetRandomValue(3)];
    if (GetRandomValue(2) && (flags & RANDOM_ACTION_TURN_TO_TARGET)) {
      action &= ~(TANK_TURN_LEFT | TANK_TURN_RIGHT);
      action |= EnemyTurnToTarget(enemy) & (TANK_TURN_LEFT | TANK_TURN_RIGHT);
    }
    for (j = 0; j < depth; j++) {
      enemy->actions[(enemy->actions_num)++] = action;
    }
  }
  return;
}

static int EscapeCanonAndMissile(Enemy enemy, Map map, 
				 ObjList tank_list, ObjList canon_list,
				 ObjList missile_list, ObjList explosion_list,
				 int range, int repeat, int depth, int count)
{
  int shot_or_escape;
  int best_shot_or_escape;
  int best_actions_num = 0;
  unsigned long int best_actions[ENEMY_ACTIONS_BUFFER_SIZE];
  int best_moved, moved;
  int i, j;
  unsigned long int action;

  best_shot_or_escape = 0;
  best_moved = -1;

  for (i = 0; i < repeat; i++) {
    SetRandomAction(enemy, depth, count, RANDOM_ACTION_NO_FLAG);
    shot_or_escape = ShotOrEscape(ESCAPE_FLAG,
				  enemy, map, tank_list, canon_list,
				  missile_list, explosion_list,
				  range, depth * count, &moved, NULL);

#if 0
    if (shot_or_escape < 0)
      return (0);
#endif

    do {
      if ( (shot_or_escape >= 0) &&
	   ((best_shot_or_escape < 0) ||
	    (best_shot_or_escape > shot_or_escape)) )
	break;
      if ((best_shot_or_escape == shot_or_escape) && (best_moved > moved))
	break;
      best_shot_or_escape = shot_or_escape;
      best_actions_num = enemy->actions_num;
      for (j = 0; j < enemy->actions_num; j++) {
	best_actions[j] = enemy->actions[j];
      }
      best_moved = moved;
    } while (0);
  }

  enemy->current_action = 0;
  enemy->actions_num = best_actions_num;
  for (j = 0; j < enemy->actions_num; j++) {
    enemy->actions[j] = best_actions[j];
  }
  enemy->escape_timer = GetRandomValue(4) + 2;

  /* ưڡ̵ʤȤꤢäƤޤ˲롪 */
  if (best_moved < 5)
    enemy->actions[enemy->current_action] |= TANK_FIRE_CANON;

  /* ޤäưʤʤȤꤢäƤߤ */
  if (best_moved == 0) {
    enemy->actions_num = GetRandomValue(3) + 2;
    if (GetRandomValue(2))
      action = TANK_TURN_LEFT;
    else
      action = TANK_TURN_RIGHT;
    for (j = 0; j < enemy->actions_num; j++) {
      enemy->actions[j] &= ~(TANK_TURN_LEFT | TANK_TURN_RIGHT);
      enemy->actions[j] |= action;
    }
    enemy->escape_timer = 3;
  }

  return (0);
}

static int ShotCanonAndMissile(Enemy enemy, Map map, 
			       ObjList tank_list, ObjList canon_list,
			       ObjList missile_list, ObjList explosion_list,
			       int range, int depth)
{
  int shot_or_escape;
  int moved;

  if (enemy->actions_num <= enemy->current_action)
    return (0);

  if (enemy->actions[enemy->current_action] &
      (TANK_FIRE_CANON | TANK_FIRE_MISSILE))
    return (0);

#if 0
  if (GetRandomValue(3))
    return (0);
#endif

  enemy->actions[enemy->current_action] |= TANK_FIRE_CANON;
  shot_or_escape = ShotOrEscape(SHOT_FLAG,
				enemy, map, tank_list, canon_list,
				missile_list, explosion_list,
				range, depth, &moved, NULL);
  if (shot_or_escape >= 0)
    return (1);
  enemy->actions[enemy->current_action] &= ~TANK_FIRE_CANON;

  if (GetRandomValue(70))
    return (0);

  enemy->actions[enemy->current_action] |= TANK_FIRE_MISSILE;
  shot_or_escape = ShotOrEscape(SHOT_FLAG,
				enemy, map, tank_list, canon_list,
				missile_list, explosion_list,
				0, 20, &moved, NULL);
  if (shot_or_escape >= 0)
    return (1);
  enemy->actions[enemy->current_action] &= ~TANK_FIRE_MISSILE;

  return (0);
}

static int EnemySelectTarget(Enemy enemy, ObjList tank_list)
{
  ObjListData current;
  Tank tank;
  double ex, ey;
  double x, y, dx, dy, d, min_d;

  ex = TankGetX(PlayerGetTank((Player)enemy));
  ey = TankGetY(PlayerGetTank((Player)enemy));
  enemy->target = NULL;

  min_d = -1.0;
  for (current = ObjList_GetStart(tank_list);
       !ObjList_IsEndEdge(tank_list, current);
       current = ObjListData_GetNext(current)) {
    tank = (Tank)ObjListData_GetObj(current);
    if (TankGetState(tank) != TANK_ACTIVE) continue;
    if (tank == PlayerGetTank((Player)enemy)) continue;
    x = TankGetX(tank);
    y = TankGetY(tank);
    dx = ex - x; dy = ey - y;
    d = dx * dx + dy * dy;
    if ((min_d < 0.0) || (min_d > d)) {
      enemy->target = tank;
      min_d = d;
    }
  }
  return (0);
}

static int NoMoveAction(Enemy enemy, Map map,
			ObjList player_list, ObjList enemy_list,
			ObjList tank_list, ObjList canon_list,
			ObjList missile_list, ObjList explosion_list)
{
  enemy->current_action = 0;
  enemy->actions_num = 1;
  enemy->actions[0] = TANK_NO_ACTION;
  return (0);
}

static int ChaserAction(Enemy enemy, Map map,
			ObjList player_list, ObjList enemy_list,
			ObjList tank_list, ObjList canon_list,
			ObjList missile_list, ObjList explosion_list)
{
  int shot_or_escape;
  int best_actions_num = 0;
  unsigned long int best_actions[ENEMY_ACTIONS_BUFFER_SIZE];
  int i, j;
  unsigned long int action = TANK_NO_ACTION;
  unsigned long int flags = RANDOM_ACTION_NO_FLAG;
  int moved, best_moved;
  double d, best_d;
  double x, y, dx, dy, dd;

  if ((enemy->target == NULL) ||
      (TankGetState(enemy->target) != TANK_ACTIVE) ||
      (GetRandomValue(20) == 0)) {
    EnemySelectTarget(enemy, tank_list);
  }

  if (enemy->target == NULL) {
    enemy->actions_num = 10;
    enemy->current_action = 0;
    for (i = 0; i < enemy->actions_num; i++) {
      enemy->actions[i] = TANK_NO_ACTION;
    }
    return (0);
  }

  if ((enemy->chase_timer > 0) &&
      (enemy->actions_num > enemy->current_action)) {
    (enemy->chase_timer)--;
    return (0);
  }

  x = TankGetX(PlayerGetTank((Player)enemy));
  y = TankGetY(PlayerGetTank((Player)enemy));
  dx = TankGetX(enemy->target) - x;
  dy = TankGetY(enemy->target) - y;
  dd = dx * dx + dy * dy;
  if (dd < 6.0 * 6.0) {
    /* Υξ */
    flags |= RANDOM_ACTION_TURN_TO_TARGET;
  }

  best_moved = 0;
  best_d = -1.0;

  for (i = 0; i < 5; i++) {
    SetRandomAction(enemy, 3, 3, flags | RANDOM_ACTION_FORWARD_ONLY);
    shot_or_escape = ShotOrEscape(ESCAPE_FLAG,
				  enemy, map, tank_list, canon_list,
				  missile_list, explosion_list,
				  0, 3 * 3, &moved, &d);
    do {
      if (shot_or_escape >= 0)
	break;
      if ((best_d >= 0.0) && (best_d <= d))
	break;
      best_actions_num = enemy->actions_num;
      for (j = 0; j < enemy->actions_num; j++) {
	best_actions[j] = enemy->actions[j];
      }
      best_moved = moved;
      best_d = d;
    } while (0);
  }

  enemy->current_action = 0;
  enemy->actions_num = best_actions_num;
  for (j = 0; j < enemy->actions_num; j++) {
    enemy->actions[j] = best_actions[j];
  }
  enemy->chase_timer = enemy->actions_num;

  /* ưڡ̵ʤȤꤢäƤޤ˲롪 */
  if (best_moved < 7)
    enemy->actions[enemy->current_action] |= TANK_FIRE_CANON;

  /* ޤäưʤʤȤꤢäƤߤ */
  if (best_moved < 2) {
    if ((GetRandomValue(4) == 0) ||
	((action = EnemyTurnToTarget(enemy)) != TANK_NO_ACTION)) {
      /* åȤ */
      enemy->actions_num = 3;
    } else {
      enemy->actions_num = GetRandomValue(4) + 3;
      if (GetRandomValue(2))
	action = TANK_TURN_LEFT;
      else
	action = TANK_TURN_RIGHT;
    }
    for (j = 0; j < enemy->actions_num; j++) {
      enemy->actions[j] &= ~(TANK_TURN_LEFT | TANK_TURN_RIGHT);
      enemy->actions[j] |= action;
    }
    enemy->current_action = 0;
    enemy->chase_timer = enemy->actions_num;
  }

  return (0);
}

#if 0
static int WaiterAction(Enemy enemy, Map map,
			ObjList player_list, ObjList enemy_list,
			ObjList tank_list, ObjList canon_list,
			ObjList missile_list, ObjList explosion_list)
{
  return (0);
}
#endif

static int WhimsyAction(Enemy enemy, Map map,
			ObjList player_list, ObjList enemy_list,
			ObjList tank_list, ObjList canon_list,
			ObjList missile_list, ObjList explosion_list)
{
  unsigned long int action;
  unsigned long int rnd;
  int i;

#if 1
  return (ChaserAction(enemy, map, player_list, enemy_list,
		       tank_list, canon_list, missile_list, explosion_list));
#endif

  if (enemy->actions_num > enemy->current_action)
    return (0);

  do {
    action = TANK_NO_ACTION;
    if (GetRandomValue(7)) {
      action &= ~(TANK_GO_FORWARD | TANK_GO_BACKWARD);
      rnd = GetRandomValue(2);
      switch (rnd) {
      case 0: action |= TANK_GO_BACKWARD; break;
      case 1: action |= TANK_GO_FORWARD;  break;
      }
    }
    if (GetRandomValue(6)) {
      action &= ~(TANK_TURN_LEFT | TANK_TURN_RIGHT);
      switch (GetRandomValue(3)) {
      case 0: action |= TANK_TURN_LEFT; break;
      case 1: action |= TANK_TURN_RIGHT; break;
      }
    }
  } while ((action & ~(TANK_GO_FORWARD | TANK_GO_BACKWARD |
		       TANK_TURN_LEFT | TANK_TURN_RIGHT)) == action);

  if (GetRandomValue(100) == 0) action |= TANK_FIRE_CANON;

  enemy->actions_num = 10;
  enemy->current_action = 0;
  for (i = 0; i < enemy->actions_num; i++) {
    enemy->actions[i] = action;
  }
  return (0);
}

unsigned long int EnemyAct(Enemy enemy, Map map_orig,
			   ObjList player_list, ObjList enemy_list,
			   ObjList tank_list, ObjList canon_list,
			   ObjList missile_list, ObjList explosion_list)
{
  Map map;
  unsigned long int action;

  if (TankGetState(PlayerGetTank((Player)enemy)) != TANK_ACTIVE) {
    return (TANK_NO_ACTION);
  }

  map = MapCreateFromMap(map_orig);

  if (enemy->escape_timer) {
    (enemy->escape_timer)--;
    if (enemy->current_action >= enemy->actions_num) {
      enemy->escape_timer = 0;
    }
    if (enemy->escape_timer == 0) {
      if (ShotOrEscape(ESCAPE_FLAG, enemy, map, tank_list, canon_list,
		       missile_list, explosion_list, 0, 7, NULL, NULL) >= 0) {
	EscapeCanonAndMissile(enemy, map, tank_list, canon_list,
			      missile_list, explosion_list, 0, 7, 3, 3);
	goto ret;
      }
    } else {
      goto ret;
    }
  }

#if 1
#elif 1
  enemy->type = ENEMY_TYPE_NOMOVE;
#else
  enemy->type = ENEMY_TYPE_CHASER;
#endif

  switch (enemy->type) {
  case ENEMY_TYPE_NOMOVE:
    NoMoveAction(enemy, map, player_list, enemy_list,
		 tank_list, canon_list,
		 missile_list, explosion_list);
    break;
  case ENEMY_TYPE_CHASER:
    ChaserAction(enemy, map, player_list, enemy_list,
		 tank_list, canon_list,
		 missile_list, explosion_list);
    break;
#if 0
  case ENEMY_TYPE_WAITER:
    WaiterAction(enemy, map, player_list, enemy_list,
		 tank_list, canon_list,
		 missile_list, explosion_list);
    break;
#endif
  case ENEMY_TYPE_WHIMSY:
    WhimsyAction(enemy, map, player_list, enemy_list,
		 tank_list, canon_list,
		 missile_list, explosion_list);
    break;
  }

  if (ShotOrEscape(ESCAPE_FLAG, enemy, map, tank_list, canon_list,
		   missile_list, explosion_list, 0, 7, NULL, NULL) >= 0) {
    EscapeCanonAndMissile(enemy, map, tank_list, canon_list,
			  missile_list, explosion_list, 0, 5, 3, 3);
  }

ret:
#if 1
  ShotCanonAndMissile(enemy, map, tank_list, canon_list,
		      missile_list, explosion_list, 0, 20);
#endif

  MapDestroy(map);
  if (enemy->actions_num > enemy->current_action) {
    action = enemy->actions[enemy->current_action];
    (enemy->current_action)++;
  } else {
    action = TANK_NO_ACTION;
  }
  return (action);
}

int EnemyInitActions(Enemy enemy)
{
  enemy->actions_num = 0;
  enemy->current_action = 0;
  return (0);
}

/*===========================================================================*/
/* ֥ȤȺ                                                  */
/*===========================================================================*/

/*---------------------------------------------------------------------------*/
/* ֥Ȥ                                                        */
/*---------------------------------------------------------------------------*/

Enemy EnemyCreate(char * name, int state, int type)
{
  Enemy enemy;

  enemy = (Enemy)malloc(sizeof(_Enemy));
  if (enemy == NULL) ErrorExit("Cannot create enemy.");

  PlayerInitialize((Player)enemy, name, NULL, state);

  if (type == ENEMY_TYPE_RANDOM)
    enemy->type = ENEMY_TYPE_START + GetRandomValue(ENEMY_TYPE_NUMBER);
  else
    enemy->type = type;

  enemy->state  = ENEMY_STATE_NONE;
  enemy->target = NULL;
  enemy->actions_num = 0;
  enemy->current_action = 0;
  enemy->chase_timer = 0;
  enemy->escape_timer = 0;

  return (enemy);
}

/*---------------------------------------------------------------------------*/
/* ֥Ȥκ                                                        */
/*---------------------------------------------------------------------------*/

Enemy EnemyDestroy(Enemy enemy)
{
  if (enemy == NULL) return (NULL);
  PlayerDone((Player)enemy);
  free(enemy);
  return (NULL);
}

/*****************************************************************************/
/* ޤ                                                                  */
/*****************************************************************************/

/*****************************************************************************/
/* End of File.                                                              */
/*****************************************************************************/
